<?php

class manufactoryCostMaterial extends manufactoryCost
{
    const ENTITY_TYPE = 'materials';

    public function init()
    {
        if (!empty($this->data)) {
            $this->data['formula'] = str_replace(',', '.', $this->data['formula']);
            $this->data['price'] = str_replace(',', '.', $this->data['price']);
        }
    }

    public function setData($data)
    {
        if (is_array($data) && array_key_exists('id', $data)) {
            parent::setData($data); // TODO: Change the autogenerated stub
        } elseif (is_numeric($data) && intval($data) > 0) {
            $this->setData($this->getModel('Material')->getById($data));
        }

    }

    public function delete()
    {
        $delete = new manufactoryCostMaterialDelete($this);
        $delete->run();

        return true;
    }

    public function save($data)
    {
        $model = $this->getModel('Material');
        $data['price'] = trim($data['price']);
        $data['formula'] = trim(str_replace(',', '.', $data['formula']));
        if ($this->getId()) {
            $material = $model->getById($this->getId());
            if (!empty($material)) {
                $model->updateById($this->getId(), $data);
                if ($material['formula'] != $data['formula'] || $material['price'] != $data['price']) {
                    $recalculate = new manufactoryCostMaterialRecalculate($this);

                    $data['update_datetime'] = date("Y-m-d H:i:s");
                }
                $model->updateById($this->getId(), $data);
                $this->setData($data);
                if (isset($recalculate) && is_object($recalculate)) {
                    $recalculate->run();
                }

            }
            $id = $this->getId();
        } else {
            $data['update_datetime'] = $data['create_datetime'] = date("Y-m-d H:i:s");
            $id = $model->insert($data);
        }

        return $id;
    }

}